unit EditorUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DXDraws, DXClass, DXInput, StdCtrls, ExtCtrls, ToolWin, ComCtrls, Menus,
  lmdctrl, lmdbtn, CheckLst, lmdcompo, lmdclass, lmdnonvS;

type
  TEditorForm = class(TForm)
    DXTimer1: TDXTimer;
    PBMP: TDXImageList;
    DXInput1: TDXInput;
    Panel1: TPanel;
    Preview: TDXDraw;
    Scrolly: TScrollBar;
    Scrollx: TScrollBar;
    Splitter1: TSplitter;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel2: TPanel;
    Klosser: TDXDraw;
    KlosserScroll: TScrollBar;
    KBMP: TDXImageList;
    PopupMenu1: TPopupMenu;
    Lagre1: TMenuItem;
    pne1: TMenuItem;
    N1: TMenuItem;
    Avslutt1: TMenuItem;
    N2: TMenuItem;
    Settings1: TMenuItem;
    Ny1: TMenuItem;
    N3: TMenuItem;
    Panel3: TPanel;
    Layers: TCheckListBox;
    PopupMenu2: TPopupMenu;
    Frombitmap: TMenuItem;
    Fromlevel: TMenuItem;
    LMDShapeHint1: TLMDShapeHint;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    LMDSpeedButton1: TLMDSpeedButton;
    ToolButton3: TToolButton;
    LMDSpeedButton2: TLMDSpeedButton;
    ToolButton4: TToolButton;
    LMDSpeedButton3: TLMDSpeedButton;
    ToolButton2: TToolButton;
    LMDSpeedButton4: TLMDSpeedButton;
    ToolButton5: TToolButton;
    LMDSpeedButton5: TLMDSpeedButton;
    ToolButton6: TToolButton;
    LMDSpeedButton6: TLMDSpeedButton;
    ToolButton7: TToolButton;
    procedure PreviewInitialize(Sender: TObject);
    procedure DXTimer1Timer(Sender: TObject; LagCount: Integer);
    procedure FormCreate(Sender: TObject);
    procedure PreviewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PreviewMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    Procedure load(f : string);
    procedure ObjDraw;
    Procedure BackgroundDraw;
    Procedure InitBmp;
    procedure RefreshKlosser;
    procedure Splitter1Moved(Sender: TObject);
    procedure KlosserMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure KlosserMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PreviewMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure KlosserMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure KlosserScrollChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Avslutt1Click(Sender: TObject);
    procedure LayersClick(Sender: TObject);
    procedure FromlevelClick(Sender: TObject);
    procedure ScrollyChange(Sender: TObject);
    procedure ScrollxChange(Sender: TObject);
    procedure LMDSpeedButton5Click(Sender: TObject);
    procedure LMDSpeedButton6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    selstarttemp,selstart,cursor,selend : tpoint;
    sellayer : integer;
  end;

const DefaultWidth = 1024;
      DefaultHeight = 512;
      DefaultLayers = 3;
      maxplayers = 10;
      maxobjs = 1024;
      UndoCount = 10;
      RedoCount = 10;

type levelextrainfotype = record
 startx,starty : integer;
 layers : integer;
 width,height : integer;
 name : string[32];
 megaobjs,bypass,background, backobjs, sprites : string[32];
 scrollbackground : byte;
 end;

type leveltype = record
 info : levelextrainfotype;
 l : array of array of array of smallint;
 end;

type playertype = array[0..maxplayers] of record
                                          objnr : integer;
                                          score : integer;
                                          name : string;
                                          end;

type objtype = array[0..maxobjs] of record
               x,y : integer;
               typo : integer;
               ax,ay : integer;
               tag : string;
               pic : integer;
               end;


type gametype = record
                level : leveltype;
                objs : objtype;
                scrollx,scrolly : integer;
                end;

var
  EditorForm: TEditorForm;
  Game : gametype;
  CurrentLayer : Byte = 1;
  Undo : array[0..UndoCount-1] of leveltype;
  Redo : array[0..UndoCount-1] of leveltype;
  FirstUndoNo : integer = 0;
  LastUndoNo : integer = 0;
  CurrentUndoNo : integer = 0;

Procedure Resetlevel;

implementation

uses editorUnit3;

{$R *.DFM}


procedure storeundo;
var l : integer;
begin
//flytte alle undoene ned

//stappe inn ny undo

//tmme redo
end;

procedure DoUndo;
begin
//flytte alle redoene ned

//stappe verste undo i redo

//flytte alle undoene opp

end;

procedure DoRedo;
begin
//flytte alle undoene ned

//stappe verste redo i undo

//flytte alle redoene opp
end;

procedure swap(var a, b : integer);
var c: integer;
begin
c:=a;
a:=b;
b:=c;
end;

Procedure EnemyMove;
begin
end;

var draw : byte;

Procedure TEditorForm.ObjDraw;
var xx,yy : integer;
begin
for xx:=0 to 9 do
 for yy:=0 to 8 do
  PBMP.items[1].draw(Preview.surface,xx*32,yy*32,10);
end;

Procedure Resetlevel;
var l,xx,yy : integer;
begin
for l:=0 to game.level.info.layers-1 do
 for xx:=0 to game.level.info.Width-1 do
  for yy:=0 to game.level.info.height-1 do
   game.level.l[l][xx,yy]:=-1;
end;

Procedure TEditorForm.BackgroundDraw;
var dx,dy,sx,sy,xx,yy : integer;
    aa : smallint;
    l : byte;
begin
{if game.scrollx div 32+preview.width div 32>game.level.info.width then
 game.scrollx:=game.level.info.width-preview.Width div 32;{}

{if game.scrolly div 32+preview.height div 32>game.level.info.height then
 game.scrolly:=game.level.info.height-preview.height div 32;{}

if game.scrollx<0 then game.scrollx:=0;
if game.scrolly<0 then game.scrolly:=0;

//rm1.dximagelist1.items[0].draw(form1.dxdraw1.surface,0,0,0);
preview.surface.fill(rgb(255,255,255));
sx:=game.scrollx shr 5;
sy:=game.scrolly shr 5;

dx:=-game.scrollx+sx shl 5;
dy:=-game.scrolly+sy shl 5;

for l:=0 to game.level.info.layers-1 do
 if layers.Checked[l] then 
  for xx:=0 to preview.width shr 5+1 do
   for yy:=0 to preview.height shr 5 +1 do
    if (xx+sx<game.level.info.width) and (yy+sy<game.level.info.height) then
     begin
     aa:=game.level.l[l][xx+sx,yy+sy];
     if aa<>-1 then Pbmp.items[1].draw(preview.surface,xx shl 5+dx,yy shl 5+dy,aa);
     if fromlevel.checked then
      if (selstart.x<=xx+sx) and (selend.x>=xx+sx) and
         (selstart.y<=yy+sy) and (selend.y>=yy+sy) then
          Pbmp.items[3].draw(Preview.Surface,xx shl 5+dx,yy shl 5+dy,0);
     end;
end;


procedure TEditorForm.PreviewInitialize(Sender: TObject);
begin
resetlevel;
end;


var curx,cury : integer;

procedure TEditorForm.DXTimer1Timer(Sender: TObject; LagCount: Integer);
var xx,yy : integer;
begin
dxinput1.Update;
if isright in dxinput1.States then
 if scrollx.position<scrollx.Max-1 then
  scrollx.position:=scrollx.position+1;

//  scrollx.SetParams(scrollx.position+1,0,game.level.info.width-preview.width div 32);

if isleft in dxinput1.States then
 if scrollx.position>0 then
  scrollx.position:=scrollx.position-1;

//  scrollx.SetParams(scrollx.position-1,0,game.level.info.width-preview.width div 32);


if isup in dxinput1.States then
 if scrolly.position>0 then
  scrolly.position:=scrolly.position-1;

 //  scrolly.SetParams(scrolly.position-1,0,game.level.info.height-preview.height div 32);

if isdown in dxinput1.States then
 if scrolly.position<scrolly.Max then
  scrolly.position:=scrolly.position+1;
//  scrolly.SetParams(scrolly.position+1,0,game.level.info.height-preview.height div 32);


game.scrolly:=scrolly.Position shl 5;
game.scrollx:=scrollx.Position shl 5;

dxinput1.Update;
if isleft in dxinput1.States then dec(curx);
if isright in dxinput1.States then inc(curx);
if isup in dxinput1.States then dec(cury);
if isdown in dxinput1.States then inc(cury);
preview.surface.fill(clwhite);
backgrounddraw;

if draw<>3 then
 for xx:=0 to selend.x-selstart.x do
  for yy:=0 to selend.y-selstart.y do
   Pbmp.items[2].draw(preview.surface,cursor.x*32+xx*32,cursor.y*32+yy*32,0);

preview.flip;

end;
function topf(a : string) : pchar;
begin
result:=pchar(a);
end;

Procedure TEditorForm.InitBmp;
begin
chdir(extractfilepath(application.exename));
if fileexists('gfx\'+game.level.info.backobjs) then
 begin
 Pbmp.items[1].Picture.loadfromfile('gfx\'+game.level.info.backobjs);
 Kbmp.items[1].Picture.loadfromfile('gfx\'+game.level.info.backobjs);
 end
 else if fileexists(game.level.info.backobjs) then
  begin
  Pbmp.items[1].Picture.loadfromfile(game.level.info.backobjs);
  Kbmp.items[1].Picture.loadfromfile(game.level.info.backobjs);
  end else messagebox(application.handle,topf('Can''t find: '+game.level.info.backobjs),'',0);
Kbmp.Items.Restore;
Pbmp.Items.Restore;
end;

procedure TEditorForm.FormCreate(Sender: TObject);
var i : integer;
begin
game.level.info.layers:=defaultlayers;
game.level.info.width:=defaultwidth;
game.level.info.height:=defaultheight;
layers.Items.Clear;
for i:=0 to game.level.info.layers-1 do layers.Items.add(inttostr(i));
for i:=0 to game.level.info.layers-1 do layers.checked[i]:=true;
layers.ItemIndex:=1;
with game.level do
 setlength(l,info.layers,info.width,info.height);

selstart:=point(0,0);
selend:=point(0,0);

if fileexists('gfx\klosser.bmp') then
 begin
 Pbmp.items[1].Picture.loadfromfile('gfx\klosser.bmp');
 Kbmp.items[1].Picture.loadfromfile('gfx\klosser.bmp');
 end else
 begin
 Pbmp.items[1].Picture.loadfromfile('klosser.bmp');
 Kbmp.items[1].Picture.loadfromfile('klosser.bmp');
 end;
PBMP.Items.Restore;
KBMP.Items.Restore;
refreshklosser;
end;


Procedure save(f : string);
var ff : file;
    dy,l : integer;
begin
if fileexists(f) then deletefile(f);
assign(ff,f);
rewrite(ff,1);
blockwrite(ff,game.level.info,sizeof(levelextrainfotype));
for l:=0 to game.level.info.layers-1 do
 for dy:=0 to game.level.info.width-1 do
  blockwrite(ff,game.level.l[l][dy,0],(game.level.info.height*2));
close(ff);
end;



Procedure teditorform.load(f : string);
var ff : file;
    l,dy,a : integer;
begin
resetlevel;
assignfile(ff,f);
reset(ff,1);
blockread(ff,game.level.info,sizeof(levelextrainfotype));
self.layers.items.Clear;
for a:=0 to game.level.info.layers-1 do
 begin
 self.layers.items.add(inttostr(a));
// self.layers.checked[a]:=true;
 end;
//self.Layers.
for a:=0 to game.level.info.layers-1 do
 begin
 self.layers.checked[a]:=true;
 end;
with game.level do setlength(l,info.layers,info.width,info.height);
for l:=0 to game.level.info.layers-1 do
 for dy:=0 to game.level.info.width-1 do
  blockread(ff,game.level.l[l][dy,0],(game.level.info.height*2));
closefile(ff);
end;


procedure TEditorForm.PreviewMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ssShift in shift then
 begin
 fromlevel.Checked:=true;
 draw:=3;
 selstarttemp:=point(x div 32+scrollx.position, y div 32+scrolly.position);
 end else
 Case Button Of
  mbLeft  : draw:=1;
  mbRight : draw:=2;
  end;
  
PreviewMouseMove(Sender,[],x,y);
end;

procedure TEditorForm.PreviewMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
draw:=0;
sellayer:=currentlayer;
end;

procedure TEditorForm.RefreshKlosser;
var xx,yy,kloss : integer;
begin
klosser.surface.Fill(clwhite);
kloss:=klosser.width div 32*KlosserScroll.Position;
for yy:=0 to (klosser.height div 32)-1 do
 for xx:=0 to (klosser.width div 32)-1 do
  if kloss<Kbmp.items[1].PatternCount then
   begin
   Kbmp.Items[1].Draw(klosser.surface,xx*32,yy*32,kloss);
   if frombitmap.checked then
    if (selstart.x<=xx) and (selend.x>=xx) and
       (selstart.y<=yy+klosserscroll.position) and (selend.y>=yy+klosserscroll.position) then
        Kbmp.Items[2].Draw(klosser.surface,xx*32,yy*32,0);

   inc(kloss);
   end else break;
//klosser.surface.Canvas.Rectangle(selstart.x*32,selstart.y*32,selend.x*32+31,selend.y*32+31);
//drawbox(selstart,selend);
// for xx:=1 to 31 do
//
// with preview.surface.Pixels[xx,yy] .Canvas do
//  begin
//  Brush.Style := bsClear;
//  Rectangle(32,32,31+32,31+32);
//  Release;
//  end;
KlosserScroll.Visible:=(kbmp.items[1].patterncount)>(klosser.height div 32)*(klosser.width div 32);
KlosserScroll.Max:=(kbmp.items[1].patterncount) div (klosser.width div 32);
if not KlosserScroll.visible then klosserscroll.Position:=0;
klosser.Flip;
end;

procedure TEditorForm.Button2Click(Sender: TObject);
var a,c,ll,xx,yy : integer;
begin
with settingsform do
 if showmodal=mrok then
 with game.level do
  begin
  info.layers:=layers.position;
  if self.layers.items.count<>info.layers then
   begin
   self.layers.items.Clear;
   for a:=0 to info.layers-1 do
    begin
    self.layers.items.add(inttostr(a));
    self.layers.checked[a]:=true;
    end;
   end;

  val(edit1.text,a,c);
  info.width:=a;

  val(edit2.text,a,c);
  info.height:=a;

  info.name:=edit3.text;
  info.sprites:=combobox1.Text;
  info.background:=combobox2.Text;
  info.backobjs:=combobox3.Text;
  info.megaobjs:=combobox4.Text;
  info.bypass:=combobox5.Text;
  setlength(l,info.layers,info.width,info.height);

  for ll:=0 to info.layers-1 do
   for xx:=0 to info.width-1 do
    for yy:=0 to info.height-1 do
     if l[ll][xx,yy]=0 then l[ll][xx,yy]:=-1;

  val(edit4.text,a,c);
  info.scrollbackground:=a;
  initbmp;

  Scrollx.Max:=game.level.info.height;
  Scrolly.Max:=game.level.info.width;
  end;
end;

procedure TEditorForm.Button1Click(Sender: TObject);
begin
if savedialog1.Execute = true then
 begin
 save(savedialog1.filename);
 savedialog1.initialdir:=extractfilepath(savedialog1.filename);
 opendialog1.FileName:=savedialog1.filename;
 end;
end;

procedure TEditorForm.Button3Click(Sender: TObject);
begin
if opendialog1.Execute = true then
 begin
 load(opendialog1.filename);
 with settingsform do
  begin
  edit1.text:=inttostr(game.level.info.width);
  edit2.text:=inttostr(game.level.info.height);
  edit3.text:=game.level.info.name;
  combobox2.text:=game.level.info.background;
  combobox3.Text:=game.level.info.backobjs;
  combobox1.text:=game.level.info.sprites;
  edit4.text:=inttostr(game.level.info.scrollbackground);
  layers.Position:=game.level.info.layers;
  end;
 initbmp;
 opendialog1.initialdir:=extractfilepath(opendialog1.filename);
 savedialog1.filename:=opendialog1.filename;
 end;
end;

procedure TEditorForm.Button4Click(Sender: TObject);
begin
if application.messagebox('Vil du tmme brettet?','',mb_yesno)=mryes then
 resetlevel;
end;

procedure TEditorForm.Splitter1Moved(Sender: TObject);
begin
refreshklosser;
end;
var marking: boolean = false;
    levelmarking : boolean = false;
procedure TEditorForm.KlosserMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
frombitmap.checked:=true;
selstarttemp:=point(x div 32,(y) div 32+klosserscroll.position);
marking:=true;
KlosserMouseMove(Sender,[],x,y);
end;

procedure TEditorForm.KlosserMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
marking:=false;
end;

procedure TEditorForm.PreviewMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var xx,yy : integer;
begin
if (x<0) or (y<0) or (x>preview.width) or (y>preview.height) then exit;
cursor.x:=x div 32;
cursor.y:=y div 32;

if draw=3 then
 begin
 selstart:=selstarttemp;
 SelEnd:=Point(x div 32+scrollx.position,y div 32+scrolly.position);
 if selend.x<selstart.x then swap(selend.x,selstart.x);
 if selend.y<selstart.y then swap(selend.Y,selstart.y);
// RefreshKlosser;
 end else
 if fromlevel.checked then
  begin
  if selend.x>=game.level.info.width  then selend.x:=game.level.info.width-1;
  if selend.y>=game.level.info.height then selend.y:=game.level.info.height-1;
  if selstart.x>=game.level.info.width  then selstart.x:=game.level.info.width-1;
  if selstart.y>=game.level.info.height then selstart.y:=game.level.info.height-1;
  end;

if draw=1 then
 if frombitmap.checked then
  begin
  for xx:=0 to (selend.x-selstart.x) do
   for yy:=0 to (selend.y-selstart.y) do
    if ((cursor.x+xx+game.scrollx div 32)<game.level.info.width) and
       ((cursor.y+yy+game.scrolly div 32)<game.level.info.height) then
    game.level.l[currentlayer][cursor.x+xx+game.scrollx div 32,cursor.y+yy+game.scrolly div 32]:=
     (klosser.width div 32)*(selstart.y+yy)+selstart.x+xx;
  end else
  begin
  for xx:=0 to (selend.x-selstart.x) do
   for yy:=0 to (selend.y-selstart.y) do
    if ((cursor.x+xx+game.scrollx div 32)<game.level.info.width) and
       ((cursor.y+yy+game.scrolly div 32)<game.level.info.height) then
    game.level.l[currentlayer][cursor.x+xx+game.scrollx div 32,cursor.y+yy+game.scrolly div 32]:=
     game.level.l[sellayer][xx+selstart.x,yy+selstart.y];
  end;

if draw=2 then
 for xx:=0 to (selend.x-selstart.x) do
  for yy:=0 to (selend.y-selstart.y) do
   if ((cursor.x+xx+game.scrollx div 32)<game.level.info.width) and
      ((cursor.y+yy+game.scrolly div 32)<game.level.info.height) then
   game.level.l[currentlayer][cursor.x+xx+game.scrollx div 32,cursor.y+yy+game.scrolly div 32]:=-1;

end;

procedure TEditorForm.KlosserMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
if marking then
 begin
 selstart:=selstarttemp;
 SelEnd:=Point(x div 32,y div 32+klosserscroll.position);
 if selend.x<selstart.x then swap(selend.x,selstart.x);
 if selend.y<selstart.y then swap(selend.Y,selstart.y);
 RefreshKlosser;
 end;
end;

procedure TEditorForm.KlosserScrollChange(Sender: TObject);
begin
refreshklosser;
end;

procedure TEditorForm.FormShow(Sender: TObject);
begin
refreshklosser;
end;

procedure TEditorForm.Avslutt1Click(Sender: TObject);
begin
Close;
end;

procedure TEditorForm.LayersClick(Sender: TObject);
begin
with layers do currentlayer:=strtoint(Items[ItemIndex]);
toolbar1.setFocus;
end;

procedure TEditorForm.FromlevelClick(Sender: TObject);
begin
if sender.ClassType=tmenuitem then
 tmenuitem(sender).checked:=true;
refreshklosser;
selstart:=point(0,0);selend:=point(0,0);
end;

procedure TEditorForm.ScrollyChange(Sender: TObject);
begin
if scrolly.max<>game.level.info.height then scrolly.max:=game.level.info.height;
end;

procedure TEditorForm.ScrollxChange(Sender: TObject);
begin
if scrollx.max<>game.level.info.width  then scrollx.max:=game.level.info.width;
end;

procedure TEditorForm.LMDSpeedButton5Click(Sender: TObject);
begin
layers.ShowHint:=tlmdspeedbutton(sender).pressed;
preview.ShowHint:=tlmdspeedbutton(sender).pressed;
klosser.ShowHint:=tlmdspeedbutton(sender).pressed;
end;

procedure TEditorForm.LMDSpeedButton6Click(Sender: TObject);
begin
chdir(extractfilepath(application.exename));
DeleteFile('j32temp.l');
if not fileexists('j32temp.l') then
 begin
 Save('j32temp.l');
 WinExec('joffa.exe j32temp.l',sw_show);
 end;
end;

end.
