unit jUnit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  lmdcompo, lmdclass, lmdformA, Buttons, ExtCtrls, StdCtrls, directx, dxdraws;

type
  TMenuForm = class(TForm)
    Quit: TSpeedButton;
    NewGame: TSpeedButton;
    RestartLevel: TSpeedButton;
    Endgame: TSpeedButton;
    Load: TSpeedButton;
    Save: TSpeedButton;
    ScreenMode: TSpeedButton;
    Image2: TImage;
    procedure EndgameClick(Sender: TObject);
    procedure QuitClick(Sender: TObject);
    procedure NewGameClick(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure LoadClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure RestartLevelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ScreenModeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MenuForm: TMenuForm;

implementation
uses unit1, Unit2_, Unit3;

{$R *.DFM}

function systemdir : string;
var temp : array[0..255] of char;
begin
GetSystemDirectory(@temp, 255);
result:=pchar(@temp);
end;

procedure TMenuForm.EndgameClick(Sender: TObject);
begin
playing:=false;
Close;
end;

procedure TMenuForm.QuitClick(Sender: TObject);
begin
  MainForm.DXTimer1.Enabled:=False;
  HelpForm.ShowModal;
  Halt;
end;

procedure TMenuForm.NewGameClick(Sender: TObject);
var a : string;
begin
  if paramstr(1)<>'' then
  begin
    game.score:=0;
    a:=paramstr(1);
    setlength(a,length(a)-2);
    chdir(extractfilepath(application.exename));
    mainform.loadworld(a);
    playing:=true;
  end else Mainform.InitGame;
  close;
end;

procedure TMenuForm.SaveClick(Sender: TObject);
var f : file of byte;
    i,l : integer;
begin
  assignfile(f,systemdir+'\joffa.sav');
  rewrite(f);
  blockwrite(f,game.score,sizeof(game.score));
  blockwrite(f,game.scrollx,sizeof(game.scrollx));
  blockwrite(f,game.scrolly,sizeof(game.scrolly));
  blockwrite(f,game.level.filename,sizeof(game.level.filename));
  blockwrite(f,game.level.currentfile,sizeof(game.level.currentfile));
  l:=length(game.objs);
  blockwrite(f,l,sizeof(l));
  for i:=0 to l-1 do
    blockwrite(f,game.objs[i],sizeof(game.objs[0]));
  CloseFile(f);
  Close;
end;

procedure TMenuForm.LoadClick(Sender: TObject);
var f : file of byte;
    sx,sy,l,i : integer;
    loadobj : objtype;
begin
  MainForm.initgame;
  assignfile(f,systemdir+'\joffa.sav');
  reset(f);
  blockread(f,game.score,sizeof(game.score));
  blockread(f,sx,sizeof(game.scrollx));
  blockread(f,sy,sizeof(game.scrolly));
  blockread(f,game.level.filename,sizeof(game.level.filename));
  blockread(f,game.level.currentfile,sizeof(game.level.currentfile));
  mainform.loadlevel(game.level.currentfile);
  blockread(f,l,sizeof(l));
  setlength(game.objs,l);
  for i:=0 to l-1 do
    BlockRead(f,game.objs[i],sizeof(loadobj));{}
  CloseFile(f);
  game.scrollx:=sx;
  game.scrolly:=sy;
  Close;
end;

procedure TMenuForm.FormActivate(Sender: TObject);
begin
  EndGame.Enabled:=(playing);
//SpeedButton5.Enabled:=(playing);
end;

procedure TMenuForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
if key=chr(27) then close;
end;

procedure TMenuForm.RestartLevelClick(Sender: TObject);
begin
with mainform do
with game.objs[myhandle] do
// if typo=99 then
 // if stall<10 then
  loadlevel(game.level.currentfile);
end;

procedure TMenuForm.FormShow(Sender: TObject);
begin
//left:=(screen.width-width) div 2;
//top:=(screen.height-height) div 2;
if doFullScreen in mainform.dxdraw1.Options then
 ScreenMode.Caption:='Windowed' else
 ScreenMode.Caption:='Fullscreen';
load.enabled:=fileexists(systemdir+'\joffa.sav');
save.enabled:=playing;
RestartLevel.Enabled:=playing;
end;

procedure TMenuForm.ScreenModeClick(Sender: TObject);
begin
MainForm.SwitchMode;
Close;
end;

end.
